# Задания

## 1. 
Установите Proxmox на две виртульные машины Proxmox. Используйте образ диска `proxmox_7.2.1.iso`. 

Параметры виртульных машин:
- объем памяти RAM 32ГБ,
- число ядер 8,
- объем жёсткого диска 32ГБ,
- vlan 15+X (сетевое устройство подключенное к мосту vmbr15+X), 
- IP из сети `192.168.1.0/24`, 
- шлюз `192.168.1.1`,
- любой общедоступный DNS, 
- стандартный пароль для пользователя root,
- доменные имена `n[1-2].studX.myoffice.ru`.

Используйте утилиту `pveversion`, чтобы узнать версию Proxmox.

## 2.
Объедините узлы в Proxmox кластер. Используйте утилиту `pvecm` (документаци> утилиты `man pvecm`). Чтобы использовать доменные имена на данном этапе внесите их в `/etc/hosts` каждой машины.
```
root@n1 # pvecm create stud15-cluster
root@n1 # systemctl restart corosync
root@n1 # pvecm status
```

```
root@n2 # pvecm add n1.stud15.myoffice.ru
root@n2 # pvecm status
```

## 3.
Настройте доступ к веб-интерфейсу с помощью прокси сервера или туннелей. Схема с туннелями:
```
Ноутбук -----------------> studX.myoffice.ru <------------------- n1.studX.myoffice.ru (vlan 15+X)

n1 $ ssh -R 8006:localhost:8006 stud@studX.myoffice.ru
notebook $ ssh -L 8006:localhost:8006 stud@studX.myoffice.ru
```

## 3.
Создайте виртуальную машину в новом Proxmox. Скачайте образ `Core` проекта `Tiny Core Linux` http://tinycorelinux.net/downloads.html.

## 4.
Сделать резервное копирование (Backup) виртуальной машины из консоли или в терминале командой `vzdump` (документация утилиты `man vzdump`). Выберите тип режима `--mode stop` без сжатия `--compress 0`. Извлеките образ из архивного формата vma (https://pve.proxmox.com/wiki/VMA)
```
vma extract -v /var/lib/vz/dump/vzdump-qemu-100-2022_10_28-17_24_31.vma /tmp/exported_vm_100_archive
``` 

Сконвертируйте образ диска в формат VDI утилитой `qemu-img`. Пример команды
```
$ qemu-img convert -f raw -O vdi /tmp/exported_vm_100_archive/disk-drive-scsi0.raw /tmp/exported_vm_100.vdi
```

Объем пространства, занимаемый образом, можно определить с помощью команд `qemu-img info` или `ls -ls`;

## 5.
Для восстановления из бекапа используется утилита `qmrestore` (`man qmrestore`). Восстановите из бэкапа виртуальную машину под другим идентификатором.

## 6.
Сделайте снимок (Snapshot) виртуальной машины командой `qm snapshot`. Найдите снимки в веб-интерфейсе и на диске.

## 7.
Создайте два новых `Linux Bridge`, объедините их в `Linux Bond`. 

## 8.
Проведите миграцию виртуальной машины с одного узла на другой командой `qm migrate` или из веб-интерфейса.

## 9.
Увеличить объем диска виртуальной машины командой `qm resize`.

## 10.
Посмотрите параметры виртуальной машины в терминале утилитой `qm config`.

## 11.
Настроите перезапуск виртуальной машины в случае отказа.

## 12.
Выведите список виртуальных машин в терминале.

## 13.
Создайте новых пользователей Proxmox `mike` и `vera`. Дайте пользователю `mike` права администратора, пользователю `vera` права пользователя виртуальными машинами.

## 14.
Попробуйте утилиту `pveperf` для анализа производительности узла.

## Релевантные источники
- https://pve.proxmox.com/wiki/Command_line_tools
- https://pve.proxmox.com/wiki/Backup_and_Restore